record Album where
  constructor MkAlbum
  artist : String
  title : String
  year: Integer

help : Album
help = MkAlbum "The Beatles" "Help" 1965

rubbersoul : Album
rubbersoul = MkAlbum "The Beatles" "Rubber Soul" 1965

clouds : Album
clouds = MkAlbum "Joni Mitchell" "Clouds" 1969

hunkydory : Album
hunkydory = MkAlbum "David Bowie" "Hunky DOry" 1971

heroes : Album
heroes = MkAlbum "David Bowie" "Heroes" 1977

collection : List Album
collection = [ help, rubbersoul, clouds, hunkydory, heroes ]

Eq Album where
  (==) (MkAlbum a t y) (MkAlbum a' t' y') = a == a' && t == t' && y == y'

Ord Album where
  compare (MkAlbum a t y) (MkAlbum a' t' y') =
    case compare a a' of
      EQ => case compare y y' of
              EQ => compare t t'
              diff_y => diff_y
      diff_a => diff_a
