module Scratch

import Data.Vect

map : (a -> b) -> Vect n a -> Vect n b
map fn [] = []
map fn (x :: []) = fn x :: map fn []
map fn (x :: (y :: [])) = fn x :: map fn [x]
map fn (x :: (y :: (z :: xs))) = fn x :: map fn (x :: (x :: xs))

len : List a -> Nat
len [] = 0
len (_ :: xs) = 1 + len(xs)
