occurrences : Eq ty => (item : ty) -> (values : List ty) -> Nat
occurrences item [] = 0
occurrences item (value :: values) = case value == item of
                                       True => 1 + occurrences item values
                                       False => occurrences item values

data Matter = Solid | Liquid | Gas

Eq Matter where
  (==) Solid Solid = True
  (==) Liquid Liquid = True
  (==) Gas Gas = True
  (==) _ _ = False

  -- (/=) x y = not (x == y)

data Tree item = Empty
               | Node (Tree item) item (Tree item)

Eq item => Eq (Tree item) where
  (==) Empty Empty = True
  (==) (Node l i r) (Node l' i' r') = l == l' && i == i' && r == r'
  (==) _ _ = False
