data PowerSource = Petrol | Pedal | Electricity

data Vehicle : PowerSource -> Type where
     Bicycle : Vehicle Pedal
     Unicycle : Vehicle Pedal
     Car : (fuel : Nat) -> Vehicle Petrol
     Bus : (fuel : Nat) -> Vehicle Petrol
     Motorcycle : (fuel : Nat) -> Vehicle Petrol
     Tram : (range : Nat) -> Vehicle Electricity
     ECar : (range : Nat) -> Vehicle Electricity

wheels : Vehicle power -> Nat
wheels Bicycle = 2
wheels Unicycle = 1
wheels (Car fuel) = 4
wheels (Bus fuel) = 4
wheels (Motorcycle fuel) = 2
wheels (Tram range) = 4
wheels (ECar range) = 4

refuel : Vehicle Petrol -> Vehicle Petrol
refuel (Car fuel) = Car 200
refuel (Bus fuel) = Bus 400
refuel (Motorcycle fuel) = Motorcycle 100
